<template>
  <v-layout>
    <v-flex xs12>
      <v-data-table
        class="elevation-3"
        item-key="userId"
        :headers="headers"
        :items="users"
        :footer-props="{
          itemsPerPageOptions: [10, 25, 50, 100, -1],
        }"
      >
        <template v-slot:body.prepend="{ isMobile }">
          <tr>
            <td :class="isMobile ? 'v-data-table__mobile-row' : ''">
              <v-text-field
                clearable
                height="25"
                color="secondary"
                v-model="filterEmail"
                label="Электронная почта"
              ></v-text-field>
            </td>
            <td :class="isMobile ? 'v-data-table__mobile-row' : ''">
              <v-text-field
                clearable
                color="secondary"
                height="25"
                v-model="filterUser"
                label="Пользователь"
              ></v-text-field>
            </td>
          </tr>
        </template>

        <template v-slot:item.created="{ item }">
          {{ item.created | datetime }}
        </template>

        <template v-slot:item.deleted="{ item }">
          <v-chip v-if="item.deleted" color="red" dark>
            <v-icon>
              {{ icons.accountRemove }}
            </v-icon>
          </v-chip>
          <v-chip v-else color="green" dark>
            <v-icon>
              {{ icons.accountCheck }}
            </v-icon>
          </v-chip>
        </template>

        <template v-slot:item.actions="{ item }">
          <v-btn icon @click="editUser(item)">
            <v-icon>{{ icons.accountEdit }}</v-icon>
          </v-btn>
        </template>

        <template v-slot:no-data>
          <v-alert :value="true" type="warning">Записи не найдены</v-alert>
        </template>
      </v-data-table>
    </v-flex>
  </v-layout>
</template>

<script>
import { Icon } from "@/helpers";

export default {
  props: {
    users: Array,
  },
  computed: {
    headers() {
      return [
        {
          text: "Электронная почта",
          value: "email",
          filter: (value) => {
            if (!this.filterEmail) return true;

            return value.search(new RegExp(this.filterEmail, "i")) > -1;
          },
        },
        {
          text: "Пользователь",
          value: "name",
          filter: (value) => {
            if (!this.filterUser) return true;

            return value.search(new RegExp(this.filterUser, "i")) > -1;
          },
        },
        {
          text: "Дата создания",
          value: "created",
        },
        {
          text: "Активность",
          value: "deleted",
        },
        { text: "", value: "actions", sortable: false },
      ];
    },
  },
  methods: {
    editUser: function (user) {
      this.$emit("edit-user", user);
    },
  },
  data: () => ({
    filterEmail: "",
    filterUser: "",
    icons: {
      accountEdit: Icon.accountEdit,
      accountCheck: Icon.accountCheck,
      accountRemove: Icon.accountRemove,
    },
  }),
  mounted() {},
};
</script>
